#ifndef _SYSCTL_H
#define _SYSCTL_H

/*==========================================================================  		
Description: 
            
            System controls   
              
Histroy:       
        
        Version:1.0.2  Date: 2011/05/10
        
          1.Add SysGetVibratorState / SysSetVibratorState / SysTriggerVibration finctions for system
        
          2.Add BCSetVibratorState / BCGetVibratorState / SysTriggerVibration finctions for bar code scaning
        
        Version:1.0.1  Date: 2011/04/04
        
           1.Add BCGetReadMode / BCSetReadMode finctions
        
        
        Version:1.0.0  Date: 2010/12/24 , Frist Release 
                 
            	            
=============================================================================*/



#ifdef __cplusplus
extern "C"
{
#endif


//======= Settings for keypad ========

#define NUMERICAL_KEY_MODE  0

#define ALPHA_KEY_MODE    (NUMERICAL_KEY_MODE+1)

#define FUNC_KEY_MODE     (NUMERICAL_KEY_MODE+2)

#define VK_POWER           0x88 

#define VK_FN              0x89

#define VK_ALPHA           0x8a

#define VK_CENTER_SCAN     0xC1

#define VK_LEFT_SCAN       0xC2

#define VK_RIGHT_SCAN      0xC3



//======= Settings for function key  =======

#define FN_KEY_BACKLIGHT           TEXT("FnBacklight")

#define FN_KEY_DEVICE_POWER        TEXT("FnDevicePower")

#define FN_KEY_BARCODE             TEXT("FnBCR")

#define FN_KEY_SIP                 TEXT("FnSIP")

#define FN_KEY_CALIBRATION         TEXT("FnCalibration")

#define FN_KEY_WLAN                TEXT("FnWLAN")

#define FN_KEY_BLUETOOTH           TEXT("FnBluetooth")

#define FN_KEY_CUT                 TEXT("FnCUT")

#define FN_KEY_COPY                TEXT("FnCOPY")

#define FN_KEY_PASTE               TEXT("FnPASTE")

#define FN_KEY_VOLUME_UP           TEXT("FnVolume+")

#define FN_KEY_VOLUME_DOWN         TEXT("FnVolume-")

#define FN_KEY_BACKLIGHT_INCREASE  TEXT("FnBacklight+")

#define FN_KEY_BACKLIGHT_DECREASE  TEXT("FnBacklight-")


//======= Settings for backlight ========

//Settings for keypad backlight 
#define KEYPAD_BL_OFF          0

#define KEYPAD_BL_ENABLE_TIMER 1

#define KEYPAD_BL_ALWAYS_ON    2

//Settings for backlight timer
#define BKL_TIMEOUT_NEVER    0

#define BKL_TIMEOUT_10_SEC   10

#define BKL_TIMEOUT_20_SEC   20

#define BKL_TIMEOUT_30_SEC   30

#define BKL_TIMEOUT_40_SEC   40

#define BKL_TIMEOUT_1_MIN    60

#define BKL_TIMEOUT_3_MIN   180

#define BKL_TIMEOUT_5_MIN   300

#define BKL_TIMEOUT_10_MIN  600

//======= Settings for boot programs ==========
#define  COLD_BOOT_INIT       0
#define  WARM_BOOT_INIT       1
#define  SLEEP_RESUME_INIT    2


//======= Settings for system ========

#define SYSTEM_BATTERY_HIGH              0x01

#define SYSTEM_BATTERY_LOW               0x02

#define SYSTEM_BATTERY_CRITICAL          0x04

#define SYSTEM_BATTERY_STATE_UNKNOWN     0xff


//======= Settings for power schemes ==========

#define AC_POWER_SCHEME_1_MIN    60

#define AC_POWER_SCHEME_2_MIN    120

#define AC_POWER_SCHEME_5_MIN    300

#define AC_POWER_SCHEME_10_MIN   600

#define AC_POWER_SCHEME_15_MIN   900

#define AC_POWER_SCHEME_30_MIN   1800

#define AC_POWER_SCHEME_NEVER    0



#define BATTERY_POWER_SCHEME_1_MIN    60

#define BATTERY_POWER_SCHEME_2_MIN    120

#define BATTERY_POWER_SCHEME_3_MIN    180

#define BATTERY_POWER_SCHEME_4_MIN    240

#define BATTERY_POWER_SCHEME_5_MIN    300

#define BATTERY_POWER_SCHEME_10_MIN   600

#define BATTERY_POWER_SCHEME_15_MIN   900

#define BATTERY_POWER_SCHEME_30_MIN   1800

#define BATTERY_POWER_SCHEME_NEVER    0

//======= Settings for CPL programs ==========

#define  CPL_PC Connection    0  
#define  CPL_Dialing          1
#define  CPL_Keyboard         2
#define  CPL_Password         3
#define  CPL_Owner            4
#define  CPL_Power            5
#define  CPL_System           6
#define  CPL_Display          7
#define  CPL_Mouse            8
#define  CPL_Stylus           9
#define  CPL_Volume_Sounds    10
#define  CPL_InputPanel       11 
#define  CPL_Remove_Programs  12             
#define  CPL_Date_Time        13  
#define  CPL_Certificates     14  
#define  CPL_Bluetooth        15
#define  CPL_Net_Connections  16


//======= Settings for vibrator ==========

#define   SYS_DIABLE_VIBRATOR  0x00

#define   SYS_SHORT_VIBRATION  0x01

#define   SYS_TWO_SHORT_VIBRATION   (SYS_SHORT_VIBRATION<<1)

#define   SYS_LONG_VIBRATION        (SYS_SHORT_VIBRATION<<2)



//======= Settings for bar code scanner ==========

#define   WM_BC_NOTIFY  (WM_APP + 180) 

#define   BC_NOTIFY_NO_EVENT           0xBC00

#define   BC_NOTIFY_START_SCAN         0xBC01

#define   BC_NOTIFY_STOP_SCAN          0xBC02

#define   BC_NOTIFY_RECEIVE_BARCODE    0xBC03

#define   BC_NOTIFY_SCAN_FAILED        0xBC04

//buzzer volume
#define   BC_BUZZER_MUTE     0x00

#define   BC_BUZZER_ENABLE   0x01

//vibration
#define   BC_DIABLE_VIBRATOR  0x00

#define   BC_SHORT_VIBRATION  0x01

#define   BC_TWO_SHORT_VIBRATION   (BC_SHORT_VIBRATION<<1)

#define   BC_LONG_VIBRATION        (BC_SHORT_VIBRATION<<2)


//output modes
#define   BC_CLIPBOARD_OUTPUT  0x01

#define   BC_KEYEVENT_OUTPUT  (BC_CLIPBOARD_OUTPUT<<1)

#define   BC_DISABLE_OUTPUT   (BC_CLIPBOARD_OUTPUT<<2)

//terminal char
#define   BC_TERMINAL_CHAR_ENTER  0x0D

#define   BC_TERMINAL_CHAR_SPACE  0x20

#define   BC_TERMINAL_CHAR_TAB    0x09

#define   BC_TERMINAL_CHAR_NONE   '\0'  

   
//read modes
#define   BC_SINGLE_READ       0

#define   BC_MULTIPLE_READ     1

#define   BC_3LABELS_READ      2


//======= Signal Strength for WLAN ==========
#define WLAN_NO_SIGNAL        0        

#define WLAN_SIGNAL_VERY_LOW  1 
                   
#define WLAN_SIGNAL_LOW       2

#define WLAN_SIGNAL_GOOD      3    

#define WLAN_SIGNAL_VERY_GOOD 4      

#define WLAN_SIGNAL_EXELLENT  5   


//=====================================
//=         Device Information        =
//=====================================

BOOL SysGetModelName(LPTSTR lpszModelName);

BOOL SysGetFirmwareVersion (LPTSTR lpszFWVersion);

BOOL SysGetSoftwareVersion (LPTSTR lpszSWVersion);

BOOL SysGetConfigNumber(LPTSTR lpszConfigNumber);

BOOL SysGetSerialNumber(LPTSTR lpszSerialNumber);

BOOL SysGetLibraryVersion(LPTSTR lpLibraryVersion);

void SysGetMemorySize (PDWORD lpROMSize,PDWORD lpRAMSize);


//=====================================
//=         Keypad Controls           =
//=====================================

BOOL SysGetKBDInputMode(PBYTE lpdwInputMode);

BOOL SysSetKBDInputMode(BYTE lwInputMode);

BOOL SysGetKeypadState(DWORD dwVKCode, PBOOL lpdwLockState);

BOOL SysSetKeypadState(DWORD dwVKCode, BOOL dwLockState);

//=====================================
//=         Function Key Controls     =
//=====================================

BOOL SysGetFxKeyPrograms(DWORD dwVKCode,LPTSTR  lpFileName ,LPTSTR lpParameters);

BOOL SysSetFxKeyPrograms(DWORD dwVKCode,LPTSTR  lpFileName ,LPTSTR lpParameters);


//=====================================
//=         Backlight Controls        =
//=====================================
BOOL SysGetScreenBrightness(PBYTE lpdwLevel);

BOOL SysSetScreenBrightness(BYTE dwLevel);


BOOL SysGetBrightnessTimer(PDWORD lpdwTimeCount);

BOOL SysSetBrightnessTimer(DWORD dwTimeCount);


BOOL SysGetKeypadBacklight(PBYTE lpdwMode);

BOOL SysSetKeypadBacklight(BYTE dwMode);

//=====================================
//=       WLAN Controls               =
//=====================================

BOOL SysSetWLANPower(DWORD dwPowerStatus);

BOOL SysGetWLANPower(LPDWORD lpdwPowerStatus);

BOOL SysGetWLANPHYAddress(LPTSTR  lpszPhyAddr);

BOOL SysGetWLANSignalStrength(PBYTE  lpSignalStrength);

//=====================================
//=       Bluetooth Controls          =
//=====================================

BOOL SysSetBluetoothPower(DWORD dwPowerStatus);

BOOL SysGetBluetoothPower(LPDWORD lpdwPowerStatus);

BOOL SysGetBluetoothPHYAddress(LPTSTR lpszPhyAddr);


//=====================================
//=       Boot Controls               =
//=====================================

int SysGetNumberOfBootProgram(DWORD dwBootMode);

BOOL SysRemoveAllBootProgram(DWORD dwBootMode);

BOOL SysGetBootProgram(DWORD dwBootMode,int dwLoadPriority,LPTSTR szProgramFile);

BOOL SysSetBootProgram(DWORD dwBootMode,int dwLoadPriority,LPTSTR szProgramFile);


//=====================================
//=       Vibrator Controls           =
//=====================================
BOOL SysGetVibratorState(PBYTE lpState)

BOOL SysSetVibratorState(BYTE dwState);

BOOL SysTriggerVibration(void);



//=====================================
//=       System Controls             =
//=====================================

BOOL SysGetACPowerScheme(PDWORD lpUerIdleTime,PDWORD lpSystemIdleTime,PDWORD lpSuspendTime);

BOOL SysSetACPowerScheme(DWORD dwUerIdleTime,DWORD dwSystemIdleTime,DWORD dwSuspendTime);

BOOL SysGetBatteryPowerScheme(PDWORD lpUerIdleTime,PDWORD lpSystemIdleTime,PDWORD lpSuspendTime);

BOOL SysSetBatteryPowerScheme(DWORD dwUerIdleTime,DWORD dwSystemIdleTime,DWORD dwSuspendTime);

void SysWarmReset(void);

BOOL SysGetACLineState(PBOOL lpACState);

BOOL SysGetMainBatteryState(PBYTE lpPowerLevel,PBOOL lpChargeState);

BOOL SysGetBackupBatteryState(PBYTE lpPowerLevel,PBOOL lpChargeState);

BOOL SysGetSIPState(PBOOL lpSIPState);

BOOL SysSetSIPState(BOOL dwSIPState);

BOOL SysStylusCalibration(void);

BOOL SysLaunchCPLProgram(BYTE dwCPLProgram);

BOOL SysStartActiveSync(void);

//=====================================
//=       BCR Controls                =
//=====================================

BOOL BCGetPower(PBOOL lpPowerState);

BOOL BCSetPower(BOOL dwState);

BOOL BCStartScan(void);

BOOL BCStopScan(void);

BOOL BCGetLastNotifyEvent(PDWORD lpNotifyEvent);

BOOL BCGetLastBarcode(LPTSTR lpszBarcode);

BOOL BCSetVibratorState(BYTE dwState);

BOOL BCGetVibratorState(PBYTE lpState);

BOOL BCGetOutputMode(PBYTE lpOutputMode);

BOOL BCSetOutputMode(BYTE dwMode);

BOOL BCGetTerminalChar(PBYTE lpTermChar);

BOOL BCSetTerminalChar(BYTE dwTermChar);

BOOL BCGetPrefix(LPTSTR lpszPrefix);

BOOL BCSetPrefix(LPTSTR lpszPrefix);

BOOL BCGetSuffix(LPTSTR lpszSuffix);

BOOL BCSetSuffix(LPTSTR lpszSuffix);

BOOL BCGetReadMode(LPDWORD lpReadMode);

BOOL BCSetReadMode(DWORD dwReadMode);

BOOL BCGetBuzzerState(PBOOL lpEnableState);

BOOL BCSetBuzzerState(BOOL dwEnableState);

#ifdef __cplusplus
}
#endif

#endif
