﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using SYSCTL;

namespace BarcodeReader_Sample
{
    public partial class Form1 : Form
    {
        BarcodeReader BCR;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            BCR = new BarcodeReader();
            BCR.NotifyEventHandler += new BarcodeReader.BCRNotifyEventHandler(BCR_NotifyEventHandler);

            checkBox_EnablePower.Checked = BCR.EnablePower;

            int index;
            switch (BCR.TerminalChar)
            {
                case TermCharType.ENTER:
                    index = 0; break;
                case TermCharType.SPACE:
                    index = 1; break;
                case TermCharType.TAB:
                    index = 2; break;
                case TermCharType.NONE:
                    index = 3; break;
                default:
                    index = -1; break;
            }
            comboBox_TerminalChar.SelectedIndex = index;

            switch (BCR.Vibrator)
            { 
                case VibratorState.DISABLE:
                    index = 0; break;
                case VibratorState.SHORT:
                    index = 1; break;
                case VibratorState.TWO_SHORT:
                    index = 2; break;
                case VibratorState.LONG:
                    index = 3; break;
            }
            comboBox_VibratorState.SelectedIndex = index;

            checkBox_EnableBuzzer.Checked = BCR.EnableBuzzer;
        }

        void BCR_NotifyEventHandler(object sender, NotifyEventArgs e)
        {
            textBox_NotifyEvent.Text = e.NotifyEvent.ToString();

            if (e.NotifyEvent == NotifyEventType.RECEIVE_BARCODE)
                textBox_BarcodeData.Text = e.BarcodeData;
            else
                textBox_BarcodeData.Text = "";
        }

        // TabPage1
        private void checkBox_EnablePower_CheckStateChanged(object sender, EventArgs e)
        {
            BCR.EnablePower = checkBox_EnablePower.Checked;
        }

        private void button_StartScan_Click(object sender, EventArgs e)
        {
            BCR.StartScan();
        }

        private void button_StopScan_Click(object sender, EventArgs e)
        {
            BCR.StopScan();
        }

        private void button_GetPrefix_Click(object sender, EventArgs e)
        {
            textBox_Prefix.Text = BCR.Prefix;
        }

        private void button_SetPrefix_Click(object sender, EventArgs e)
        {
            BCR.Prefix = textBox_Prefix.Text;
        }

        private void button_GetSuffix_Click(object sender, EventArgs e)
        {
            textBox_Suffix.Text = BCR.Suffix;
        }

        private void button_SetSuffix_Click(object sender, EventArgs e)
        {
            BCR.Suffix = textBox_Suffix.Text;
        }

        // TabPage2
        private void comboBox_VibratorState_SelectedIndexChanged(object sender, EventArgs e)
        {
            VibratorState state = VibratorState.DISABLE;

            switch (comboBox_VibratorState.SelectedIndex)
            { 
                case 0:
                    state = VibratorState.DISABLE; break;
                case 1:
                    state = VibratorState.SHORT; break;
                case 2:
                    state = VibratorState.TWO_SHORT; break;
                case 3:
                    state = VibratorState.LONG; break;
            }

            BCR.Vibrator = state;
        }

        private void comboBox_TerminalChar_SelectedIndexChanged(object sender, EventArgs e)
        {
            TermCharType type;

            switch (comboBox_TerminalChar.SelectedIndex)
            {
                case 0:
                    type = TermCharType.ENTER; break;
                case 1:
                    type = TermCharType.SPACE; break;
                case 2:
                    type = TermCharType.TAB; break;
                case 3:
                    type = TermCharType.NONE; break;
                default:
                    type = TermCharType.ENTER; break;
            }

            BCR.TerminalChar = type;
        }

        private void checkBox_EnableBuzzer_CheckStateChanged(object sender, EventArgs e)
        {
            BCR.EnableBuzzer = checkBox_EnableBuzzer.Checked;
        }

        

        

    }
}